! Leonardo Marques, 06/89041, Engenharia Elétrica - UnB
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: gfortran 
! Sistema Operacional: Mandriva 2009.1

! Problema:
! Gera quadrado mágico de tamanho NxN, tal que N seja ímpar.

! Dependecias: rotinas3.1.f90

PROGRAM quadrado; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        INTEGER :: planetario; ! armazena constante matematica
        INTEGER :: dimensao; ! dimensao da matrix
        INTEGER, DIMENSION(:,:), ALLOCATABLE :: square; ! matrix com o quadrado magico
        INTEGER :: linha, coluna; ! Controle dos laços
        INTEGER :: tmplinha, tmpcoluna; ! Armazenamento temporario dos cotroles
        INTEGER :: contador; ! Controle do laço
        INTEGER, PARAMETER :: unidade = 100; ! Unidade para escrita
        CHARACTER(Len=*), PARAMETER :: output = './output_quadrado.txt'; ! Arquivo de saida
        INTEGER :: estado; ! Controle de entrada dos dados

        !Dados do programador 
        PRINT *, '% Leonardo Marques, 06/89041';
        PRINT *, '% Engenharia Elétrica, 5º semestre';
        PRINT *, '% Data de hoje 30/11/09'; 
        PRINT *, '% Programa escape.'; PRINT *, '';

        
        planetario = (dimensao+dimensao**3)/2; ! Calcula número planetário.
        
        ! Recebe a dimensao desejada
        PRINT*,'% Entre a dimensao desejada para geração do quadrado mágico, deve ser um número inteiro impar: ';
        READ(IOSTAT=estado, FMT=*, UNIT=*), dimensao;
        
        IF((estado /= 0) .OR. (dimensao <= 2)) STOP 'erro na entrada da dimensao';
       
        ! Imprime dados de entrada 
        PRINT*, '% Dimensao: ', dimensao;
        PRINT*, '% Número planetário: ', planetario;
        
        ALLOCATE(square(dimensao,dimensao)); ! Aloca a dimensao desejada

        square = 0; ! Zera a matrix inicialmente 

        ! Mostra a matrix inicialmente preenchida de zeros
        PRINT*, '* Square Matrix ', dimensao, 'x', dimensao, 'preenchida com zeros';
        DO linha = 1, dimensao, 1
                PRINT*, (square(linha,coluna), coluna=1, dimensao);
        END DO
                 
        ! Comeco do algoritmo do quadrado
        linha = 1;
        coluna = (dimensao+1)/2; 
        square(linha,coluna) = 1; ! Preenche a posicao 1x1

        PRINT*, '*  operações de preenchimento do quadrado mágico:';
        DO contador = 2, dimensao**2, 1
                        ! Armazena os valores iniciais de linha e coluna
                        tmplinha = linha;
                        tmpcoluna = coluna;
        
                        ! Sobe na diagonal direita 
                        linha = linha - 1;
                        coluna = coluna + 1;

                        ! Testa se explode as dimensoes
                        IF (linha == 0) linha = dimensao;
                        IF (coluna == dimensao + 1) coluna = 1;

                        ! Testa se o campo já está preenchido
                        IF (square(linha,coluna) /= 0) THEN
                                ! Recupera os valores iniciais
                                coluna = tmpcoluna;
                                linha = tmplinha + 1;                                

                                square(linha,coluna) = contador;
                                PRINT*, '* Square \ 0: ', 'Valor: ',square(linha,coluna),'Linha: ',linha,'Coluna: ',coluna;
                        ELSE ! Caso o campo não esteja preenchido. 
                                square(linha,coluna) = contador;
                                PRINT*, '* Square = 0: ', 'Valor: ',square(linha,coluna),'Linha: ',linha,'Coluna: ',coluna;
                        END IF;
        END DO

        ! Abre arquivo para escrita
        CALL escrita(output,unidade);
       
        ! Resultado salvo no arquivo de saída
        PRINT*,''; PRINT*, '% Saída salva em ', output; 
        WRITE(UNIT=unidade, FMT=*), 'Square Matrix ', dimensao, 'x', dimensao, 'magica';
        DO linha = 1, dimensao, 1
                WRITE(UNIT=unidade, FMT=*) (square(linha,coluna), coluna=1,dimensao);
        END DO

END PROGRAM quadrado;
