! MEU BANCO DE ROTINAS
! Última alteração 1/12/09

SUBROUTINE crossprod(a,cross) ! Começo funcao cross
        IMPLICIT NONE;
        REAL, DIMENSION(2,3), INTENT(IN) :: a;
        REAL, DIMENSION(3), INTENT(OUT) :: cross;
        cross(1) = a(1,2)*a(2,3)-a(2,2)*a(1,3); ! Calcula i
        cross(2) = -1*(a(1,1)*a(2,3)-a(2,1)*a(1,3)); ! Calcula j
        cross(3) = a(1,1)*a(2,2)-a(2,1)*a(1,2)! Calcula k
END SUBROUTINE crossprod; ! fim funcao cross

SUBROUTINE leitura(arquivo, unidade); ! Abrir arquivo para leitura
        IMPLICIT NONE;
        CHARACTER(Len=*), INTENT(IN) :: arquivo;
        INTEGER, INTENT(IN) :: unidade;
        INTEGER :: teste;
        OPEN(UNIT=unidade, FILE=arquivo, STATUS='OLD', ACCESS='SEQUENTIAL', &
        & ACTION='READ', IOSTAT=teste);
        IF (teste /= 0) STOP 'Erro de leitura do arquivo de entrada.&
        & Gere um arquivo válido';
END SUBROUTINE leitura; ! Fim abrir arquivo para leitura

SUBROUTINE leitura_direta(arquivo, unidade); ! Abrir arquivo para leitura
        IMPLICIT NONE;
        CHARACTER(Len=*), INTENT(IN) :: arquivo;
        INTEGER, INTENT(IN) :: unidade;
        INTEGER :: teste;
        OPEN(UNIT=unidade, FILE=arquivo, STATUS='OLD', ACCESS='DIRECT', &
        & ACTION='READ', IOSTAT=teste, RECL=25);
        IF (teste /= 0) STOP 'Erro de leitura do arquivo de entrada.&
        & Gere um arquivo válido';
END SUBROUTINE leitura_direta; ! Fim abrir arquivo para leitura

SUBROUTINE escrita(arquivo, unidade); ! Abrir arquivo para escrita
        IMPLICIT NONE;
        CHARACTER(Len=*), INTENT(IN) :: arquivo;
        INTEGER, INTENT(IN) :: unidade;
        OPEN(UNIT=unidade, FILE=arquivo, STATUS='UNKNOWN', ACCESS='SEQUENTIAL', &
        & ACTION='WRITE');
END SUBROUTINE escrita; ! Fim abrir arquivo para escrita

SUBROUTINE matrixproduct(matrixA,matrixB,lines,mproduct) ! Comeco rotina matrixproduct
        IMPLICIT NONE;
        REAL, DIMENSION(lines,lines), INTENT(IN) :: matrixA;
        REAL, DIMENSION(lines), INTENT(IN) :: matrixB;
        REAL, DIMENSION(lines), INTENT(OUT) :: mproduct;
        INTEGER, INTENT(IN) :: lines;
        INTEGER :: i,j;

        mproduct = 0;
        DO i = 1, lines, 1
                DO j = 1, lines, 1
                        mproduct(i) = mproduct(i)+matrixA(i,j)*matrixB(j);
                END DO
        END DO
END SUBROUTINE matrixproduct; ! Fim rotina matrixproduct
